"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlReviewSlide = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var theme_1 = require("./theme");
var react_1 = require("react");
var GlLogo_1 = require("./utils/GlLogo");
var Paper_1 = __importDefault(require("@mui/material/Paper"));
var theme_2 = require("./theme");
var Markdown_1 = require("./tools/Markdown");
exports.GlReviewSlide = (0, react_1.memo)(function (props) {
    var descriptionMd = props.descriptionMd, className = props.className, signature = props.signature, logoUrl = props.logoUrl, logoFill = props.logoFill;
    var _a = useStyles(undefined, { props: props }), classes = _a.classes, cx = _a.cx;
    return ((0, jsx_runtime_1.jsxs)(Paper_1.default, __assign({ className: cx(classes.root, className) }, { children: [logoUrl !== undefined && ((0, jsx_runtime_1.jsx)(GlLogo_1.GlLogo, { fill: logoFill, logoUrl: logoUrl, className: classes.logo })), (0, jsx_runtime_1.jsxs)("div", { children: [descriptionMd !== undefined && ((0, jsx_runtime_1.jsx)(Markdown_1.Markdown, __assign({ className: classes.paragraph }, { children: descriptionMd }))), signature !== undefined && ((0, jsx_runtime_1.jsx)(theme_1.Text, __assign({ typo: "body 2", className: classes.signature }, { children: signature })))] })] })));
});
var useStyles = (0, theme_1.makeStyles)({ "name": { GlReviewSlide: exports.GlReviewSlide } })(function (theme) { return ({
    "root": {
        "display": "flex",
        "alignItems": "center",
        "justifyContent": "space-between",
        "flexDirection": (function () {
            if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                return "row";
            }
            return "column";
        })(),
    },
    "paragraph": __assign(__assign({}, theme.typography.variants["body 1"].style), { "textAlign": (function () {
            if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                return undefined;
            }
            return "center";
        })(), "margin": (function () {
            if (theme.windowInnerWidth >= theme_2.breakpointsValues.sm) {
                return theme.spacing(5);
            }
            return theme.spacing({
                "topBottom": 1,
                "rightLeft": 5,
            });
        })() }),
    "signature": __assign(__assign({ "fontStyle": "italic" }, theme.spacing.rightLeft("margin", "".concat(theme.spacing(5), "px"))), { "marginBottom": theme.spacing(5), "textAlign": (function () {
            if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                return "right";
            }
            return "center";
        })() }),
    "logo": __assign({ "width": 70, "& svg": {
            "width": 70,
            "height": 70,
        } }, (function () {
        if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
            return {
                "marginLeft": theme.spacing(5),
            };
        }
        return {
            "marginLeft": 0,
            "marginTop": theme.spacing(5),
        };
    })()),
}); });
//# sourceMappingURL=GlReviewSlide.js.map