"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getStoryFactory = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var onyxia_ui_1 = require("onyxia-ui");
var id_1 = require("tsafe/id");
var symToStr_1 = require("tsafe/symToStr");
var lib_1 = require("onyxia-ui/lib");
var ThemeProvider = (0, onyxia_ui_1.createThemeProvider)({}).ThemeProvider;
function getStoryFactory(params) {
    var wrappedComponent = params.wrappedComponent, sectionName = params.sectionName, defaultWidth = params.defaultWidth, _a = params.argTypes, argTypes = _a === void 0 ? {} : _a;
    var title = "".concat(sectionName, "/").concat((0, symToStr_1.symToStr)(wrappedComponent));
    var Component = Object.entries(wrappedComponent).map(function (_a) {
        var _b = __read(_a, 2), component = _b[1];
        return component;
    })[0];
    var Template = function (args) {
        var darkMode = args.darkMode;
        var setIsDarkModeEnabled = (0, lib_1.useIsDarkModeEnabled)().setIsDarkModeEnabled;
        (0, react_1.useEffect)(function () {
            setIsDarkModeEnabled(darkMode);
        }, [darkMode]);
        return ((0, jsx_runtime_1.jsx)(ThemeProvider, { children: (0, jsx_runtime_1.jsx)(ContentWrapper, { Component: (0, jsx_runtime_1.jsx)(Component, __assign({}, args)), width: defaultWidth }) }));
    };
    var getStory = function (props) {
        var out = Template.bind({});
        out.args = __assign({ "darkMode": true }, props);
        return out;
    };
    return {
        "meta": (0, id_1.id)({
            title: title,
            "component": Component,
            "argTypes": __assign({}, argTypes),
        }),
        getStory: getStory,
    };
}
exports.getStoryFactory = getStoryFactory;
var ContentWrapper = (function () {
    var ContentWrapper = (0, react_1.memo)(function (props) {
        var Component = props.Component, width = props.width;
        return ((0, jsx_runtime_1.jsx)("div", __assign({ style: {
                "maxWidth": width,
            } }, { children: Component })));
    });
    return { ContentWrapper: ContentWrapper };
})().ContentWrapper;
//# sourceMappingURL=getStory.js.map