/// <reference types="react" />
import type { ThemeProviderProps } from "onyxia-ui";
import type { IllustrationProps } from "./tools/IllustrationProps";
export declare function useTheme(): {
    paddingRightLeft: number;
    customShadow: string;
    borderRadius: number;
    colors: {
        palette: {
            focus: {
                main: string;
                light: string;
                light2: string;
            };
            dark: {
                main: string;
                light: string;
                greyVariant1: string;
                greyVariant2: string;
                greyVariant3: string;
                greyVariant4: string;
            };
            light: {
                main: string;
                light: string;
                greyVariant1: string;
                greyVariant2: string;
                greyVariant3: string;
                greyVariant4: string;
            };
            redError: {
                main: string;
                light: string;
            };
            greenSuccess: {
                main: string;
                light: string;
            };
            orangeWarning: {
                main: string;
                light: string;
            };
            blueInfo: {
                main: string;
                light: string;
            };
        };
        useCases: {
            typography: {
                textPrimary: string;
                textSecondary: string;
                textTertiary: string;
                textDisabled: string;
                textFocus: string;
            };
            buttons: {
                actionHoverPrimary: string;
                actionHoverSecondary: string;
                actionHoverTernary: string;
                actionSelected: string;
                actionActive: string;
                actionDisabled: string;
                actionDisabledBackground: string;
            };
            surfaces: {
                background: string;
                surface1: string;
                surface2: string;
            };
            alertSeverity: {
                error: {
                    main: string;
                    background: string;
                };
                success: {
                    main: string;
                    background: string;
                };
                warning: {
                    main: string;
                    background: string;
                };
                info: {
                    main: string;
                    background: string;
                };
            };
        };
    };
    isDarkModeEnabled: boolean;
    typography: import("onyxia-ui").ComputedTypography<never>;
    shadows: readonly ["none", "0px 6px 10px 0px rgba(0,0,0,0.07)", "0px 4px 4px 0px rgba(0,0,0,0.1)", "6px 0px 16px 0px rgba(0,0,0,0.15)", "4px 0px 10px 0px rgba(0,0,0,0.07)", "-4px 0px 10px 0px rgba(0,0,0,0.07)", "0px 6px 10px 0px rgba(0,0,0,0.14)", "0px 8px 10px -7px rgba(0,0,0,0.07)"];
    spacing: import("onyxia-ui").Spacing;
    muiTheme: import("@mui/material").Theme;
    iconSizesInPxByName: Record<"medium" | "default" | "large" | "small" | "extra small", number>;
    windowInnerWidth: number;
};
export declare const makeStyles: <Params = void, RuleNameSubsetReferencableInNestedSelectors extends string = never>(params?: {
    name?: string | Record<string, unknown> | undefined;
    uniqId?: string | undefined;
} | undefined) => <RuleName extends string>(cssObjectByRuleNameOrGetCssObjectByRuleName: Record<RuleName, import("tss-react/types").CSSObject> | ((theme: {
    paddingRightLeft: number;
    customShadow: string;
    borderRadius: number;
    colors: {
        palette: {
            focus: {
                main: string;
                light: string;
                light2: string;
            };
            dark: {
                main: string;
                light: string;
                greyVariant1: string;
                greyVariant2: string;
                greyVariant3: string;
                greyVariant4: string;
            };
            light: {
                main: string;
                light: string;
                greyVariant1: string;
                greyVariant2: string;
                greyVariant3: string;
                greyVariant4: string;
            };
            redError: {
                main: string;
                light: string;
            };
            greenSuccess: {
                main: string;
                light: string;
            };
            orangeWarning: {
                main: string;
                light: string;
            };
            blueInfo: {
                main: string;
                light: string;
            };
        };
        useCases: {
            typography: {
                textPrimary: string;
                textSecondary: string;
                textTertiary: string;
                textDisabled: string;
                textFocus: string;
            };
            buttons: {
                actionHoverPrimary: string;
                actionHoverSecondary: string;
                actionHoverTernary: string;
                actionSelected: string;
                actionActive: string;
                actionDisabled: string;
                actionDisabledBackground: string;
            };
            surfaces: {
                background: string;
                surface1: string;
                surface2: string;
            };
            alertSeverity: {
                error: {
                    main: string;
                    background: string;
                };
                success: {
                    main: string;
                    background: string;
                };
                warning: {
                    main: string;
                    background: string;
                };
                info: {
                    main: string;
                    background: string;
                };
            };
        };
    };
    isDarkModeEnabled: boolean;
    typography: import("onyxia-ui").ComputedTypography<never>;
    shadows: readonly ["none", "0px 6px 10px 0px rgba(0,0,0,0.07)", "0px 4px 4px 0px rgba(0,0,0,0.1)", "6px 0px 16px 0px rgba(0,0,0,0.15)", "4px 0px 10px 0px rgba(0,0,0,0.07)", "-4px 0px 10px 0px rgba(0,0,0,0.07)", "0px 6px 10px 0px rgba(0,0,0,0.14)", "0px 8px 10px -7px rgba(0,0,0,0.07)"];
    spacing: import("onyxia-ui").Spacing;
    muiTheme: import("@mui/material").Theme;
    iconSizesInPxByName: Record<"medium" | "default" | "large" | "small" | "extra small", number>;
    windowInnerWidth: number;
}, params: Params, classes: Record<RuleNameSubsetReferencableInNestedSelectors, string>) => Record<RuleNameSubsetReferencableInNestedSelectors | RuleName, import("tss-react/types").CSSObject>)) => (params: Params, styleOverrides?: {
    props: {
        classes?: Record<string, string> | undefined;
    } & Record<string, unknown>;
    ownerState?: Record<string, unknown> | undefined;
} | undefined) => {
    classes: Record<RuleName, string>;
    theme: {
        paddingRightLeft: number;
        customShadow: string;
        borderRadius: number;
        colors: {
            palette: {
                focus: {
                    main: string;
                    light: string;
                    light2: string;
                };
                dark: {
                    main: string;
                    light: string;
                    greyVariant1: string;
                    greyVariant2: string;
                    greyVariant3: string;
                    greyVariant4: string;
                };
                light: {
                    main: string;
                    light: string;
                    greyVariant1: string;
                    greyVariant2: string;
                    greyVariant3: string;
                    greyVariant4: string;
                };
                redError: {
                    main: string;
                    light: string;
                };
                greenSuccess: {
                    main: string;
                    light: string;
                };
                orangeWarning: {
                    main: string;
                    light: string;
                };
                blueInfo: {
                    main: string;
                    light: string;
                };
            };
            useCases: {
                typography: {
                    textPrimary: string;
                    textSecondary: string;
                    textTertiary: string;
                    textDisabled: string;
                    textFocus: string;
                };
                buttons: {
                    actionHoverPrimary: string;
                    actionHoverSecondary: string;
                    actionHoverTernary: string;
                    actionSelected: string;
                    actionActive: string;
                    actionDisabled: string;
                    actionDisabledBackground: string;
                };
                surfaces: {
                    background: string;
                    surface1: string;
                    surface2: string;
                };
                alertSeverity: {
                    error: {
                        main: string;
                        background: string;
                    };
                    success: {
                        main: string;
                        background: string;
                    };
                    warning: {
                        main: string;
                        background: string;
                    };
                    info: {
                        main: string;
                        background: string;
                    };
                };
            };
        };
        isDarkModeEnabled: boolean;
        typography: import("onyxia-ui").ComputedTypography<never>;
        shadows: readonly ["none", "0px 6px 10px 0px rgba(0,0,0,0.07)", "0px 4px 4px 0px rgba(0,0,0,0.1)", "6px 0px 16px 0px rgba(0,0,0,0.15)", "4px 0px 10px 0px rgba(0,0,0,0.07)", "-4px 0px 10px 0px rgba(0,0,0,0.07)", "0px 6px 10px 0px rgba(0,0,0,0.14)", "0px 8px 10px -7px rgba(0,0,0,0.07)"];
        spacing: import("onyxia-ui").Spacing;
        muiTheme: import("@mui/material").Theme;
        iconSizesInPxByName: Record<"medium" | "default" | "large" | "small" | "extra small", number>;
        windowInnerWidth: number;
    };
    css: import("tss-react/types").Css;
    cx: import("tss-react/types").Cx;
};
export declare const Text: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<{
    className?: string | null | undefined;
    typo: import("onyxia-ui").TypographyDesc.VariantNameBase;
    color?: "disabled" | "primary" | "secondary" | "focus" | undefined;
    children: string | number | boolean | import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>> | import("react").ReactFragment | import("react").ReactPortal;
    htmlComponent?: import("onyxia-ui").TypographyDesc.HtmlComponent | undefined;
    componentProps?: import("react").DetailedHTMLProps<import("react").AnchorHTMLAttributes<HTMLAnchorElement>, HTMLAnchorElement> | import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLDivElement>, HTMLDivElement> | import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLHeadingElement>, HTMLHeadingElement> | import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLParagraphElement>, HTMLParagraphElement> | import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLSpanElement>, HTMLSpanElement> | undefined;
    fixedSize_enabled?: boolean | undefined;
    fixedSize_content?: string | undefined;
    fixedSize_fontWeight?: number | undefined;
} & import("react").RefAttributes<any>>>;
export declare const Icon: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<import("onyxia-ui/Icon").IconProps<"brightness4" | "brightness7" | "arrowBackIos" | "arrowForwardIos" | "dehaze" | "brightness1Rounded"> & import("react").RefAttributes<SVGSVGElement>>>;
export declare const IconButton: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<import("onyxia-ui/IconButton").IconButtonProps<"brightness4" | "brightness7" | "arrowBackIos" | "arrowForwardIos" | "dehaze" | "brightness1Rounded"> & import("react").RefAttributes<HTMLButtonElement>>>;
export declare const Button: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<import("onyxia-ui/Button").ButtonProps<"brightness4" | "brightness7" | "arrowBackIos" | "arrowForwardIos" | "dehaze" | "brightness1Rounded"> & import("react").RefAttributes<HTMLButtonElement>>>;
export declare const breakpointsValues: {
    "lg+": 1440;
    sm: 600;
    md: 960;
    lg: 1280;
    xl: 1920;
};
export declare const splashScreen: ThemeProviderProps["splashScreen"];
export declare const useIllustrationStyles: (params: {
    aspectRatio: number;
    illustrationZoomFactor: number | undefined;
    type: IllustrationProps["type"] | undefined;
}, styleOverrides?: {
    props: {
        classes?: Record<string, string> | undefined;
    } & Record<string, unknown>;
    ownerState?: Record<string, unknown> | undefined;
} | undefined) => {
    classes: Record<"root", string>;
    theme: {
        paddingRightLeft: number;
        customShadow: string;
        borderRadius: number;
        colors: {
            palette: {
                focus: {
                    main: string;
                    light: string;
                    light2: string;
                };
                dark: {
                    main: string;
                    light: string;
                    greyVariant1: string;
                    greyVariant2: string;
                    greyVariant3: string;
                    greyVariant4: string;
                };
                light: {
                    main: string;
                    light: string;
                    greyVariant1: string;
                    greyVariant2: string;
                    greyVariant3: string;
                    greyVariant4: string;
                };
                redError: {
                    main: string;
                    light: string;
                };
                greenSuccess: {
                    main: string;
                    light: string;
                };
                orangeWarning: {
                    main: string;
                    light: string;
                };
                blueInfo: {
                    main: string;
                    light: string;
                };
            };
            useCases: {
                typography: {
                    textPrimary: string;
                    textSecondary: string;
                    textTertiary: string;
                    textDisabled: string;
                    textFocus: string;
                };
                buttons: {
                    actionHoverPrimary: string;
                    actionHoverSecondary: string;
                    actionHoverTernary: string;
                    actionSelected: string;
                    actionActive: string;
                    actionDisabled: string;
                    actionDisabledBackground: string;
                };
                surfaces: {
                    background: string;
                    surface1: string;
                    surface2: string;
                };
                alertSeverity: {
                    error: {
                        main: string;
                        background: string;
                    };
                    success: {
                        main: string;
                        background: string;
                    };
                    warning: {
                        main: string;
                        background: string;
                    };
                    info: {
                        main: string;
                        background: string;
                    };
                };
            };
        };
        isDarkModeEnabled: boolean;
        typography: import("onyxia-ui").ComputedTypography<never>;
        shadows: readonly ["none", "0px 6px 10px 0px rgba(0,0,0,0.07)", "0px 4px 4px 0px rgba(0,0,0,0.1)", "6px 0px 16px 0px rgba(0,0,0,0.15)", "4px 0px 10px 0px rgba(0,0,0,0.07)", "-4px 0px 10px 0px rgba(0,0,0,0.07)", "0px 6px 10px 0px rgba(0,0,0,0.14)", "0px 8px 10px -7px rgba(0,0,0,0.07)"];
        spacing: import("onyxia-ui").Spacing;
        muiTheme: import("@mui/material").Theme;
        iconSizesInPxByName: Record<"medium" | "default" | "large" | "small" | "extra small", number>;
        windowInnerWidth: number;
    };
    css: import("tss-react/types").Css;
    cx: import("tss-react/types").Cx;
};
